/* Copyright (c) 2004 Konrad Kieling <kkieling@users.sourceforge.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

var docarcUrls = new Array( );
var docarcAdded = false;

function docarcInit( )
  {
  docarcCreateUrls( );

  if ( ! docarcAdded )
    {
    docarcAdded = true;
    docarcAddDS( docarcUrls['docs'] , document.getElementById( 'NC:PersonalToolbarFolder' ) );
    }

  document.getElementById( 'contentAreaContextMenu' ).addEventListener( 'popupshowing', docarcTestClipboard, true );
  document.getElementById( 'taskPopup' ).addEventListener( 'popupshowing', docarcAddModes, true );
  }

function docarcAddModes( )
  { docarcAddDS( docarcUrls['modes'], document.getElementById( 'docarcMenu' ) ); }

function docarcAddDS( rt, tree )
  {
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService( ).QueryInterface( Components.interfaces.nsIRDFService );
  var sources = ( rt + ' ' + tree.getAttribute( "sources" ) ).match( /[^\s]+/g );

  if( sources )
    {
    for( i = 0; i < sources.length; ++ i )
      {
      var ds = Components.classes['@mozilla.org/rdf/datasource;1?name=xml-datasource'].createInstance( Components.interfaces.nsIRDFRemoteDataSource );
      try { ds.Init( sources[i] ); ds.Refresh( false ); } catch ( e ) { ds = rdf.GetDataSource( sources[i] ); }
      tree.database.AddDataSource( ds );
      }
    tree.builder.rebuild( );
    }
  }

function docarcGetPostStream( string )
  {
  var stream = Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance( Components.interfaces.nsIStringInputStream );
  var content = [ 'Content-Length: ' + string.length + '\n', string ].join( '\n' );
  stream.setData( content, content.length );

  return stream;
  }

function docarcParseBibTeX( mode, content )
  {
  document.getElementById('content').webNavigation.loadURI(
    docarcUrls['pure'],
    Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
    null,
    docarcGetPostStream( 'rm=mod_parse_bibtex&mode=' + mode + '&cmd=parse&content=' + escape( content ) ),
    null
  );
  }

function docarcParseDocument( value )
  {
  var params = value.match( /[^\s]+/g );
  var serializer = new XMLSerializer( );
  docarcParseBibTeX( params[0], serializer.serializeToString( document.getElementById( 'content' ).contentDocument ) );
  }

function docarcParseSelection( )
  {
  var xferable = Components.classes['@mozilla.org/widget/transferable;1'].createInstance( Components.interfaces.nsITransferable );
  var clipboard = Components.classes['@mozilla.org/widget/clipboard;1'].getService( Components.interfaces.nsIClipboard );
  var flavour = { };
  var data    = { };
  var length  = { };

  document.getElementById( 'content' ).contentViewerEdit.copySelection( );

  xferable.addDataFlavor( "text/unicode" );
  clipboard.getData( xferable, Components.interfaces.nsIClipboard.kGlobalClipboard );

  xferable.getAnyTransferData( flavour, data, length );
  docarcParseBibTeX( 'plain', data.value.QueryInterface( Components.interfaces.nsISupportsWString ).data );
  }

function docarcTestClipboard( )
  { document.getElementById( 'docarcSelection' ).setAttribute( 'hidden', !document.getElementById( 'content' ).contentViewerEdit.copyable ); }

function docarcCreateUrls( )
  {
  try
    {
    var bmPref = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService ).getBranch( "extensions.docarc." );
    docarcUrls['pure'] = bmPref.getCharPref( 'url' );

    if ( docarcUrls['pure'].search( /http:\/\// ) == 0 )
      { docarcUrls['auth'] = docarcUrls['pure'].substr( 0, 7 ) + bmPref.getCharPref( 'username' ) + ':' + bmPref.getCharPref( 'password' ) + '@' +
                             docarcUrls['pure'].substring( 7, docarcUrls['pure'].length ); }
    else { docarcUrls['auth'] = docarcUrls['pure'] };
    }
  catch ( e ) { }

  docarcUrls['docs']  = docarcUrls['auth'] + '?rm=search&query=&queryfield=any&limit=-1&format=rdf&categories=1';
  docarcUrls['modes'] = docarcUrls['auth'] + '?rm=mod_parse_bibtex&cmd=modeslist&format=rdf';
  }

function docarcTestUrls( event )
  {
  for( i = 0; i < event.target.childNodes.length; i++ )
    {
    var params = event.target.childNodes[i].getAttribute( 'value' ).match( /[^\s]+/g );
    if ( ( params ) && ( params.length > 1 ) )
      { event.target.childNodes[i].setAttribute( 'disabled', document.getElementById( 'content' ).webNavigation.currentURI.spec.search( params[1] ) != 0 ); }
    else { event.target.childNodes[i].removeAttribute( 'disabled' ); }
    }
  }

window.addEventListener( "load", docarcInit, true );
